searchNodes=[{"doc":"Module for parsing and serializing MP4 files. Bases on MP4 structure specification from Membrane.MP4.Container.Schema .","ref":"Membrane.MP4.Container.html","title":"Membrane.MP4.Container","type":"module"},{"doc":"Maps a path in the MP4 box tree into sequence of keys under which that box resides in MP4.","ref":"Membrane.MP4.Container.html#box_path/1","title":"Membrane.MP4.Container.box_path/1","type":"function"},{"doc":"Gets a box from a given path in a parsed MP4.","ref":"Membrane.MP4.Container.html#get_box/2","title":"Membrane.MP4.Container.get_box/2","type":"function"},{"doc":"Parses binary data to MP4 according to Membrane.MP4.Container.Schema.schema/0 . Returns boxes that have been correctly parsed, and the leftover data that is insufficient to constitute a complete box.","ref":"Membrane.MP4.Container.html#parse/1","title":"Membrane.MP4.Container.parse/1","type":"function"},{"doc":"Parses binary data to MP4 according to a custom schema. Returns boxes that have been correctly parsed, and the leftover data that is insufficient to constitute a complete box.","ref":"Membrane.MP4.Container.html#parse/2","title":"Membrane.MP4.Container.parse/2","type":"function"},{"doc":"Same as parse/1 , raises on error.","ref":"Membrane.MP4.Container.html#parse!/1","title":"Membrane.MP4.Container.parse!/1","type":"function"},{"doc":"Same as parse/2 , raises on error.","ref":"Membrane.MP4.Container.html#parse!/2","title":"Membrane.MP4.Container.parse!/2","type":"function"},{"doc":"Serializes MP4 to a binary according to Membrane.MP4.Container.Schema.schema/0 .","ref":"Membrane.MP4.Container.html#serialize/1","title":"Membrane.MP4.Container.serialize/1","type":"function"},{"doc":"Serializes MP4 to a binary according to a custom schema.","ref":"Membrane.MP4.Container.html#serialize/2","title":"Membrane.MP4.Container.serialize/2","type":"function"},{"doc":"Same as serialize/1 , raises on error","ref":"Membrane.MP4.Container.html#serialize!/1","title":"Membrane.MP4.Container.serialize!/1","type":"function"},{"doc":"Same as serialize/2 , raises on error","ref":"Membrane.MP4.Container.html#serialize!/2","title":"Membrane.MP4.Container.serialize!/2","type":"function"},{"doc":"Updates a box at a given path in a parsed MP4. If parameter_path is set, a parameter within a box is updated.","ref":"Membrane.MP4.Container.html#update_box/4","title":"Membrane.MP4.Container.update_box/4","type":"function"},{"doc":"","ref":"Membrane.MP4.Container.html#t:box_name_t/0","title":"Membrane.MP4.Container.box_name_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.html#t:field_name_t/0","title":"Membrane.MP4.Container.field_name_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.html#t:fields_t/0","title":"Membrane.MP4.Container.fields_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.html#t:parse_error_context_t/0","title":"Membrane.MP4.Container.parse_error_context_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.html#t:serialize_error_context_t/0","title":"Membrane.MP4.Container.serialize_error_context_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.html#t:t/0","title":"Membrane.MP4.Container.t/0","type":"type"},{"doc":"A structure describing the header of the box. The content_size field is equal to the box size minus the size of the header (8 bytes).","ref":"Membrane.MP4.Container.Header.html","title":"Membrane.MP4.Container.Header","type":"module"},{"doc":"Parses the header of a box. Returns the t/0 and the leftover data.","ref":"Membrane.MP4.Container.Header.html#parse/1","title":"Membrane.MP4.Container.Header.parse/1","type":"function"},{"doc":"","ref":"Membrane.MP4.Container.Header.html#t:t/0","title":"Membrane.MP4.Container.Header.t/0","type":"type"},{"doc":"MP4 structure schema used for parsing and serialization. Useful resources: https://www.iso.org/standard/79110.html https://www.iso.org/standard/61988.html https://developer.apple.com/library/archive/documentation/QuickTime/QTFF/QTFFChap2/qtff2.html https://github.com/DicomJ/mpeg-isobase/tree/eb09f82ff6e160715dcb34b2bf473330c7695d3b","ref":"Membrane.MP4.Container.Schema.html","title":"Membrane.MP4.Container.Schema","type":"module"},{"doc":"Returns Membrane.MP4.Container.Schema.t/0","ref":"Membrane.MP4.Container.Schema.html#schema/0","title":"Membrane.MP4.Container.Schema.schema/0","type":"function"},{"doc":"A box field type. It may contain a primitive, a list or nested fields. Lists last till the end of a box.","ref":"Membrane.MP4.Container.Schema.html#t:field_t/0","title":"Membrane.MP4.Container.Schema.field_t/0","type":"type"},{"doc":"For fields, the following primitive types are supported: {:int, bit_size} - a signed integer {:uint, bit_size} - an unsigned integer :bin - a binary lasting till the end of a box {:bin, bit_size} - a binary of given size :str - a string terminated with a null byte {:str, bit_size} - a string of given size {:fp, integer_part_bit_size, fractional_part_bit_size} - a fixed point number","ref":"Membrane.MP4.Container.Schema.html#t:primitive_t/0","title":"Membrane.MP4.Container.Schema.primitive_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_box_t/0","title":"Membrane.MP4.Container.Schema.schema_def_box_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_field_t/0","title":"Membrane.MP4.Container.Schema.schema_def_field_t/0","type":"type"},{"doc":"","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_primitive_t/0","title":"Membrane.MP4.Container.Schema.schema_def_primitive_t/0","type":"type"},{"doc":"Type describing the schema definition, that is hardcoded in this module. It may be useful for improving the schema definition. The actual schema that should be operated on, or, in other words, the parsed schema definition is specified by Membrane.MP4.Container.Schema.t/0 . The schema definition differs from the final schema in the following ways: primitives along with their parameters are specified as atoms, for example :int32 instead of {:int, 32} child boxes are nested within their parents directly, instead of residing under :children key. The schema definition is the following: [ ftyp : [ fields : [ major_brand : :str32 , major_brand_version : :uint32 , compatible_brands : { :list , :str32 } ] ] , moov : [ mvhd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , creation_time : :uint32 , modification_time : :uint32 , timescale : :uint32 , duration : :uint32 , rate : :fp16d16 , volume : :fp8d8 , reserved : &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , matrix_value_A : :fp16d16 , matrix_value_B : :fp16d16 , matrix_value_U : :fp2d30 , matrix_value_C : :fp16d16 , matrix_value_D : :fp16d16 , matrix_value_V : :fp2d30 , matrix_value_X : :fp16d16 , matrix_value_Y : :fp16d16 , matrix_value_W : :fp2d30 , quicktime_preview_time : :uint32 , quicktime_preview_duration : :uint32 , quicktime_poster_time : :uint32 , quicktime_selection_time : :uint32 , quicktime_selection_duration : :uint32 , quicktime_current_time : :uint32 , next_track_id : :uint32 ] ] , trak : [ tkhd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , creation_time : :uint32 , modification_time : :uint32 , track_id : :uint32 , reserved : &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , duration : :uint32 , reserved : &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , layer : :int16 , alternate_group : :int16 , volume : :fp8d8 , reserved : &lt;&lt; 0 , 0 &gt;&gt; , matrix_value_A : :fp16d16 , matrix_value_B : :fp16d16 , matrix_value_U : :fp2d30 , matrix_value_C : :fp16d16 , matrix_value_D : :fp16d16 , matrix_value_V : :fp2d30 , matrix_value_X : :fp16d16 , matrix_value_Y : :fp16d16 , matrix_value_W : :fp2d30 , width : :fp16d16 , height : :fp16d16 ] ] , mdia : [ mdhd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , creation_time : :uint32 , modification_time : :uint32 , timescale : :uint32 , duration : :uint32 , reserved : &lt;&lt; 0 :: size ( 1 ) &gt;&gt; , language : :uint15 , reserved : &lt;&lt; 0 , 0 &gt;&gt; ] ] , hdlr : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , reserved : &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , handler_type : :str32 , reserved : &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , name : :str ] ] , minf : [ vmhd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , graphics_mode : :uint16 , opcolor : :uint48 ] ] , smhd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , balance : :fp8d8 , reserved : &lt;&lt; 0 , 0 &gt;&gt; ] ] , dinf : [ dref : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , entry_count : :uint32 ] , url : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } ] ] ] ] , stbl : [ stsd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , entry_count : :uint32 ] , avc1 : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , num_of_entries : :uint32 , reserved : &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , width : :uint16 , height : :uint16 , horizresolution : :fp16d16 , vertresolution : :fp16d16 , reserved : &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , frame_count : :uint16 , compressor_name : :str256 , depth : :uint16 , reserved : &lt;&lt; 255 , 255 &gt;&gt; ] , avcC : [ black_box? : true ] , pasp : [ fields : [ h_spacing : :uint32 , v_spacing : :uint32 ] ] ] , mp4a : [ fields : [ reserved : &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , data_reference_index : :uint16 , encoding_version : :uint16 , encoding_revision : :uint16 , encoding_vendor : :uint32 , channel_count : :uint16 , sample_size : :uint16 , compression_id : :uint16 , packet_size : :uint16 , sample_rate : :fp16d16 ] , esds : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , elementary_stream_descriptor : :bin ] ] ] , Opus : [ version : 0 , fields : [ reserved : &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , data_reference_index : :uint16 , reserved : &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , channel_count : :uint16 , sample_size : :uint16 , reserved : &lt;&lt; 0 , 0 &gt;&gt; , reserved : &lt;&lt; 0 , 0 &gt;&gt; , sample_rate : :uint32 ] , dOps : [ version : 0 , fields : [ version : :uint8 , output_channel_count : :uint8 , pre_skip : :uint16 , input_sample_rate : :uint32 , output_gain : :int16 , channel_mapping_family : :uint8 ] ] ] ] , stts : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , entry_count : :uint32 , entry_list : { :list , [ sample_count : :uint32 , sample_delta : :uint32 ] } ] ] , stss : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , entry_count : :uint32 , entry_list : { :list , [ sample_number : :uint32 ] } ] ] , stsc : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , entry_count : :uint32 , entry_list : { :list , [ first_chunk : :uint32 , samples_per_chunk : :uint32 , sample_description_index : :uint32 ] } ] ] , stsz : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , sample_size : :uint32 , sample_count : :uint32 , entry_list : { :list , [ entry_size : :uint32 ] } ] ] , stco : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , entry_count : :uint32 , entry_list : { :list , [ chunk_offset : :uint32 ] } ] ] ] ] ] ] , mvex : [ trex : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , track_id : :uint32 , default_sample_description_index : :uint32 , default_sample_duration : :uint32 , default_sample_size : :uint32 , default_sample_flags : :uint32 ] ] ] ] , styp : [ fields : [ major_brand : :str32 , major_brand_version : :uint32 , compatible_brands : { :list , :str32 } ] ] , sidx : [ version : 1 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , reference_id : :uint32 , timescale : :uint32 , earliest_presentation_time : :uint64 , first_offset : :uint64 , reserved : &lt;&lt; 0 , 0 &gt;&gt; , reference_count : :uint16 , reference_type : :bin1 , referenced_size : :uint31 , subsegment_duration : :uint32 , starts_with_sap : :bin1 , sap_type : :uint3 , sap_delta_time : :uint28 ] ] , moof : [ mfhd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , sequence_number : :uint32 ] ] , traf : [ tfhd : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , track_id : :uint32 , default_sample_duration : :uint32 , default_sample_size : :uint32 , default_sample_flags : :uint32 ] ] , tfdt : [ version : 1 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , base_media_decode_time : :uint64 ] ] , trun : [ version : 0 , fields : [ version : :uint8 , flags : { :uint24 , [ store : :fo_flags ] } , sample_count : :uint32 , data_offset : :int32 , samples : { :list , [ sample_duration : :uint32 , sample_size : :uint32 , sample_flags : :bin32 , sample_offset : { :uint32 , [ when : { 2048 , :fo_flags } ] } ] } ] ] ] ] , mdat : [ black_box? : true ] ]","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_t/0","title":"Membrane.MP4.Container.Schema.schema_def_t/0","type":"type"},{"doc":"The schema of MP4 structure. An MP4 file consists of boxes, that all have the same header and different internal structures. Boxes can be nested with one another. Each box has at most 4-letter name and may have the following parameters: black_box? - if true, the box content is unspecified and is treated as an opaque binary. Defaults to false. version - the box version. Versions usually differ by the sizes of particular fields. fields - a list of key-value parameters children - the nested boxes","ref":"Membrane.MP4.Container.Schema.html#t:t/0","title":"Membrane.MP4.Container.Schema.t/0","type":"type"},{"doc":"A module defining a structure that represents an MPEG-4 track. All new samples of a track must be stored in the structure first in order to build a sample table of a regular MP4 container. Samples that were stored can be flushed later in form of chunks.","ref":"Membrane.MP4.Track.html","title":"Membrane.MP4.Track","type":"module"},{"doc":"","ref":"Membrane.MP4.Track.html#current_chunk_duration/1","title":"Membrane.MP4.Track.current_chunk_duration/1","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.html#finalize/2","title":"Membrane.MP4.Track.finalize/2","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.html#flush_chunk/2","title":"Membrane.MP4.Track.flush_chunk/2","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.html#new/1","title":"Membrane.MP4.Track.new/1","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.html#store_sample/2","title":"Membrane.MP4.Track.store_sample/2","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.html#t:t/0","title":"Membrane.MP4.Track.t/0","type":"type"},{"doc":"A module that defines a structure and functions allowing to store samples, assemble them into chunks and flush when needed. Its public functions take care of recording information required to build a sample table. For performance reasons, the module uses prepends when storing information about new samples. To compensate for it, use &amp;Membrane.MP4.Track.SampleTable.reverse/1 when it's known that no more samples will be stored.","ref":"Membrane.MP4.Track.SampleTable.html","title":"Membrane.MP4.Track.SampleTable","type":"module"},{"doc":"","ref":"Membrane.MP4.Track.SampleTable.html#chunk_duration/1","title":"Membrane.MP4.Track.SampleTable.chunk_duration/1","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.SampleTable.html#flush_chunk/2","title":"Membrane.MP4.Track.SampleTable.flush_chunk/2","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.SampleTable.html#reverse/1","title":"Membrane.MP4.Track.SampleTable.reverse/1","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.SampleTable.html#store_sample/2","title":"Membrane.MP4.Track.SampleTable.store_sample/2","type":"function"},{"doc":"","ref":"Membrane.MP4.Track.SampleTable.html#t:t/0","title":"Membrane.MP4.Track.SampleTable.t/0","type":"type"},{"doc":"Puts payloaded stream into Common Media Application Format , an MP4-based container commonly used in adaptive streaming over HTTP. Multiple input streams are supported. If that is the case, they will be muxed into a single CMAF Track. Given that all input streams need to have a keyframe at the beginning of each CMAF Segment, it is recommended that all input streams are renditions of the same content. The muxer also supports creation of partial segments that do not begin with a key frame when the partial_segment_duration_range is specified. The muxer tries to create many partial segments to match the regular segment target duration. When reaching the regular segment's target duration the muxer tries to perform lookaheads of the samples to either create a shorter/longer partial segment so that a new segment can be started (beginning with a keyframe). If a stream contains non-key frames (like H264 P or B frames), they should be marked with a mp4_payload: %{key_frame?: false} metadata entry. Element options Passed via struct Membrane.MP4.Muxer.CMAF.t/0 segment_duration_range SegmentDurationRange . t ( ) Default value: %Membrane.MP4.Muxer.CMAF.SegmentDurationRange{min: 2000000000, target: 2000000000} partial_segment_duration_range SegmentDurationRange . t ( ) | nil Default value: nil The duration range of partial segments. If set to nil , the muxer assumes it should not produce partial segments Pads :input Accepted formats: Membrane.MP4.Payload Direction: :input Availability: :on_request Mode: :pull Demand mode: :manual Demand unit: :buffers :output Accepted formats: Membrane.CMAF.Track Direction: :output Availability: :always Mode: :pull Demand mode: :manual","ref":"Membrane.MP4.Muxer.CMAF.html","title":"Membrane.MP4.Muxer.CMAF","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.MP4.Muxer.CMAF.html#options/0","title":"Membrane.MP4.Muxer.CMAF.options/0","type":"function"},{"doc":"Struct containing options for Membrane.MP4.Muxer.CMAF","ref":"Membrane.MP4.Muxer.CMAF.html#t:t/0","title":"Membrane.MP4.Muxer.CMAF.t/0","type":"type"},{"doc":"Structure specifying the minimal and target duration for a CMAF segment. Each regular CMAF segment usually has to begin with a key frame. Sometimes the video stream can have irregularly occurring key frames which can influence the duration of a single segment. It may happen that the segment duration significantly exceeds the target duration as the samples are aggregated until reaching a key frame which allows for finalizing the current segment and starting a new one. Irregular key frames Let's study the following example: we are streaming with an OBS on a mediocre machine segment's target duration is set to 2 seconds, so we are expecting a key frame every 2 seconds partial's segment target duration is set to 0.5 seconds so we want to create 4 partial segments for each segment The broadcasting machine becomes overloaded and the OBS starts to drop the frame rate, as a result the key frames don't get produced regularly every 2 seconds but sometimes it may happen after 1.2 seconds or so and then it may get back to normal. In this case we would produce 2 partial segments and a half. With a naive approach we could just try to gather 4 partial segments and with the 5 we just aggregate samples until reaching a key frame but in this case the last segments could be even 1.2 seconds long (as we are expecting to get the next key frame at around 3.2 seconds). The idea is to have minimal and target durations. We just need to ensure that segments would have at least the minimal duration after which we can perform lookaheads for key frames so that we can end the partial segment early and start a new one. In our case we would produce 2 full partial segments and one with a duration of 0.2 seconds. Effectively, the third partial segment would start with a key frame.","ref":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.html","title":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange","type":"module"},{"doc":"","ref":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.html#new/1","title":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.new/1","type":"function"},{"doc":"","ref":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.html#new/2","title":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.new/2","type":"function"},{"doc":"","ref":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.html#validate/1","title":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.validate/1","type":"function"},{"doc":"","ref":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.html#t:t/0","title":"Membrane.MP4.Muxer.CMAF.SegmentDurationRange.t/0","type":"type"},{"doc":"Puts payloaded streams into an MPEG-4 container. Due to the structure of MPEG-4 containers, the muxer has to be used along with Membrane.File.Sink or any other sink that can handle Membrane.File.SeekEvent . The event is used to fill in mdat box size after processing all incoming buffers and, if fast_start is set to true , to insert moov box at the beginning of the file. Element options Passed via struct Membrane.MP4.Muxer.ISOM.t/0 fast_start boolean ( ) Default value: false Generates a container more suitable for streaming by allowing media players to start playback as soon as they start to receive its media data. When set to true , the container metadata ( moov atom) will be placed before media data ( mdat atom). The equivalent of FFmpeg's -movflags faststart option. chunk_duration Time . t ( ) Default value: 1000000000 Expected duration of each chunk in the resulting MP4 container. Once the total duration of samples received on one of the input pads exceeds that threshold, a chunk containing these samples is flushed. Interleaving chunks belonging to different tracks may have positive impact on performance of media players. Pads :input Accepted formats: Membrane.MP4.Payload Direction: :input Availability: :on_request Mode: :pull Demand mode: :manual Demand unit: :buffers :output Accepted formats: % RemoteStream { type : :bytestream , content_format : MP4 } Direction: :output Availability: :always Mode: :pull Demand mode: :manual","ref":"Membrane.MP4.Muxer.ISOM.html","title":"Membrane.MP4.Muxer.ISOM","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.MP4.Muxer.ISOM.html#options/0","title":"Membrane.MP4.Muxer.ISOM.options/0","type":"function"},{"doc":"Struct containing options for Membrane.MP4.Muxer.ISOM","ref":"Membrane.MP4.Muxer.ISOM.html#t:t/0","title":"Membrane.MP4.Muxer.ISOM.t/0","type":"type"},{"doc":"A Membrane Element for demuxing an MP4. The MP4 must have fast start enabled, i.e. the moov box must precede the mdat box. Once the Demuxer identifies the tracks in the MP4, new_track_t/0 notification is sent for each of the tracks. All the tracks in the MP4 must have a corresponding output pad linked ( Pad.ref(:output, track_id) ). Pads :input Accepted formats: % RemoteStream { type : :bytestream , content_format : content_format } when content_format in [ nil , MP4 ] Direction: :input Availability: :always Mode: :pull Demand mode: :manual Demand unit: :buffers :output Accepted formats: Membrane.MP4.Payload Direction: :output Availability: :on_request Mode: :pull Demand mode: :manual","ref":"Membrane.MP4.Demuxer.ISOM.html","title":"Membrane.MP4.Demuxer.ISOM","type":"module"},{"doc":"Notification sent when a new track is identified in the MP4. Upon receiving the notification a Pad.ref(:output, track_id) pad should be linked. The content field describes the kind of Membrane.MP4.Payload which is contained in the track.","ref":"Membrane.MP4.Demuxer.ISOM.html#t:new_track_t/0","title":"Membrane.MP4.Demuxer.ISOM.new_track_t/0","type":"type"},{"doc":"Payloads AAC stream so it can be embedded in MP4. Resources: Packaging/Encapsulation And Setup Data section of https://wiki.multimedia.cx/index.php/Understanding_AAC Element options Passed via struct Membrane.MP4.Payloader.AAC.t/0 avg_bit_rate non_neg_integer ( ) Default value: 0 Average stream bitrate. Should be set to 0 if unknown. max_bit_rate non_neg_integer ( ) Default value: 0 Maximal stream bitrate. Should be set to 0 if unknown. Pads :input Accepted formats: % Membrane.AAC { encapsulation : :none } Direction: :input Availability: :always Mode: :pull Demand mode: :manual Demand unit: :buffers :output Accepted formats: Membrane.MP4.Payload Direction: :output Availability: :always Mode: :pull Demand mode: :manual","ref":"Membrane.MP4.Payloader.AAC.html","title":"Membrane.MP4.Payloader.AAC","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.MP4.Payloader.AAC.html#options/0","title":"Membrane.MP4.Payloader.AAC.options/0","type":"function"},{"doc":"Struct containing options for Membrane.MP4.Payloader.AAC","ref":"Membrane.MP4.Payloader.AAC.html#t:t/0","title":"Membrane.MP4.Payloader.AAC.t/0","type":"type"},{"doc":"Payloads H264 stream so it can be embedded in MP4. Element options Passed via struct Membrane.MP4.Payloader.H264.t/0 parameters_in_band? boolean ( ) Default value: false Determines whether the parameter type nalus will be removed from the stream. Inband parameters seem to be legal with MP4, but some players don't respond kindly to them, so use at your own risk. NALUs currently considered to be parameters: :sps, :pps, :aus. Pads :input Accepted formats: % Membrane.H264 { alignment : :au , nalu_in_metadata? : true } Direction: :input Availability: :always Mode: :pull Demand mode: :manual Demand unit: :buffers :output Accepted formats: Membrane.MP4.Payload Direction: :output Availability: :always Mode: :pull Demand mode: :manual","ref":"Membrane.MP4.Payloader.H264.html","title":"Membrane.MP4.Payloader.H264","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.MP4.Payloader.H264.html#options/0","title":"Membrane.MP4.Payloader.H264.options/0","type":"function"},{"doc":"Struct containing options for Membrane.MP4.Payloader.H264","ref":"Membrane.MP4.Payloader.H264.html#t:t/0","title":"Membrane.MP4.Payloader.H264.t/0","type":"type"},{"doc":"MP4 Payloader for Opus codec. Pads :input Accepted formats: % Opus { self_delimiting? : false } Direction: :input Availability: :always Mode: :pull Demand mode: :manual Demand unit: :buffers :output Accepted formats: Payload Direction: :output Availability: :always Mode: :pull Demand mode: :manual","ref":"Membrane.MP4.Payloader.Opus.html","title":"Membrane.MP4.Payloader.Opus","type":"module"},{"doc":"A module containing a function for assembling an MPEG-4 file type box. The file type box ( ftyp atom) is a top-level box that contains specifications and compatibility information that media players can use to correctly interpret an MPEG-4 container. For more information about the file type box, refer to ISO/IEC 14496-12 .","ref":"Membrane.MP4.FileTypeBox.html","title":"Membrane.MP4.FileTypeBox","type":"module"},{"doc":"","ref":"Membrane.MP4.FileTypeBox.html#assemble/3","title":"Membrane.MP4.FileTypeBox.assemble/3","type":"function"},{"doc":"A module containing a function for assembling an MPEG-4 media data box. The media data box ( mdat atom) is a top-level box that contains actual media data (e.g. encoded video frames or audio samples). The data is logically divided into so called &quot;chunks&quot; that consist of &quot;samples&quot;. There are no assumptions made about chunks arrangement or sizes in the MPEG-4 specification and chunks belonging to different tracks can (and should) be interleaved. For more information about media data box, refer to ISO/IEC 14496-12 .","ref":"Membrane.MP4.MediaDataBox.html","title":"Membrane.MP4.MediaDataBox","type":"module"},{"doc":"","ref":"Membrane.MP4.MediaDataBox.html#assemble/1","title":"Membrane.MP4.MediaDataBox.assemble/1","type":"function"},{"doc":"A module providing a function assembling an MPEG-4 movie box. The movie box ( moov ) is a top-level box that contains information about a presentation as a whole. It consists of: exactly one movie header ( mvhd atom) The movie header contains media-independent data, such as the number of tracks, volume, duration or timescale (presentation-wide). one or more track box ( trak atom) zero or one movie extends box ( mvex atom) For more information about movie box and its contents, refer to documentation of Membrane.MP4.MovieBox submodules or to ISO/IEC 14496-12 .","ref":"Membrane.MP4.MovieBox.html","title":"Membrane.MP4.MovieBox","type":"module"},{"doc":"","ref":"Membrane.MP4.MovieBox.html#assemble/2","title":"Membrane.MP4.MovieBox.assemble/2","type":"function"},{"doc":"The module provides a function that assembles an MPEG-4 movie extends box ( mvex atom). The movie extends box provides information about movie fragment boxes in case when media data is fragmented (for example in CMAF). It has to contain as many track extends box ( trex atoms) as there are tracks in the movie box. For more information about the movie extends box, refer to ISO/IEC 14496-12 .","ref":"Membrane.MP4.MovieBox.MovieExtendsBox.html","title":"Membrane.MP4.MovieBox.MovieExtendsBox","type":"module"},{"doc":"","ref":"Membrane.MP4.MovieBox.MovieExtendsBox.html#assemble/1","title":"Membrane.MP4.MovieBox.MovieExtendsBox.assemble/1","type":"function"},{"doc":"A module containing a set of utilities for assembling an MPEG-4 track box. The track box ( trak atom) describes a single track of a presentation. This description includes information like its timescale, duration, volume, media-specific data (media handlers, sample descriptions) as well as a sample table, which allows media players to find and interpret track's data in the media data box. For more information about the track box, refer to ISO/IEC 14496-12 .","ref":"Membrane.MP4.MovieBox.TrackBox.html","title":"Membrane.MP4.MovieBox.TrackBox","type":"module"},{"doc":"","ref":"Membrane.MP4.MovieBox.TrackBox.html#assemble/1","title":"Membrane.MP4.MovieBox.TrackBox.assemble/1","type":"function"},{"doc":"","ref":"Membrane.MP4.MovieBox.TrackBox.html#unpack/1","title":"Membrane.MP4.MovieBox.TrackBox.unpack/1","type":"function"},{"doc":"A module containing a function for assembling an MPEG-4 movie fragment box. The movie fragment box ( moof atom) is a top-level box and consists of: exactly one movie fragment header ( mfhd atom) The movie fragment header contains a sequence number that is increased for every subsequent movie fragment in order in which they occur. zero or more track fragment box ( traf atom) The track fragment box provides information related to a track fragment's presentation time, duration and physical location of its samples in the media data box. This box is required by Common Media Application Format. For more information about movie fragment box and its contents refer to ISO/IEC 14496-12 or to ISO/IEC 23000-19 .","ref":"Membrane.MP4.MovieFragmentBox.html","title":"Membrane.MP4.MovieFragmentBox","type":"module"},{"doc":"","ref":"Membrane.MP4.MovieFragmentBox.html#assemble/1","title":"Membrane.MP4.MovieFragmentBox.assemble/1","type":"function"},{"doc":"A module containing a function for assembling a CMAF segment index box. The segment index box ( sidx atom) contains information related to presentation time and byte-range locations of other boxes belonging to its segment. For more information about segment index box refer to ISO/IEC 23000-19 .","ref":"Membrane.MP4.SegmentIndexBox.html","title":"Membrane.MP4.SegmentIndexBox","type":"module"},{"doc":"","ref":"Membrane.MP4.SegmentIndexBox.html#assemble/1","title":"Membrane.MP4.SegmentIndexBox.assemble/1","type":"function"},{"doc":"A module containing a function for assembling a CMAF segment type box. The segment type box ( styp atom) is a top-level box that contains specifications and compatibility information that media players can use to correctly interpret a CMAF segment. For more information about the segment type box, refer to ISO/IEC 23000-19 .","ref":"Membrane.MP4.SegmentTypeBox.html","title":"Membrane.MP4.SegmentTypeBox","type":"module"},{"doc":"","ref":"Membrane.MP4.SegmentTypeBox.html#assemble/3","title":"Membrane.MP4.SegmentTypeBox.assemble/3","type":"function"},{"doc":"This plugin provides utilities for MP4 container parsing and serialization along with elements for muxing the stream to MP4 or CMAF .","ref":"readme.html","title":"MPEG-4 container plugin for Membrane Framework","type":"extras"},{"doc":"The package can be installed by adding membrane_mp4_plugin to your list of dependencies in mix.exs : defp deps do [ { :membrane_mp4_plugin , &quot;~&gt; 0.19.0&quot; } ] end","ref":"readme.html#installation","title":"MPEG-4 container plugin for Membrane Framework - Installation","type":"extras"},{"doc":"Membrane.MP4.Muxer.ISOM ISOM muxer requires a sink that can handle Membrane.File.SeekEvent , e.g. Membrane.File.Sink . For an example of muxing streams to a regular MP4 file, refer to examples/muxer_isom.exs . To run the example, you can use the following command: elixir examples/muxer_isom.exs You can expect an example.mp4 file containing muxed audio and video to be saved in your working directory. ### Membrane.MP4.Muxer.CMAF For an example of muxing streams into CMAF format, refer to examples/muxer_cmaf.exs . CMAF requires a special sink, regular Membrane.File.Sink will not work correctly. Currently, Membrane Framework has only one sink capable of saving a CMAF stream - Membrane.HTTPAdaptiveStream.Sink . To run the example, use the following command: elixir examples/muxer_cmaf.exs You can expect hls_output folder to appear and be filled with CMAF header and segments, as well as an HLS playlist. To play the stream, you need to serve the contents of the output folder with an HTTP Server. If you are looking for something quick and simple, you can use Python's http.server : python3 -m http.server -d hls_output 8000 and run the following command to play the stream: ffplay http://localhost:8000/index.m3u8 ## Updating tests In case out_* reference files in test/fixtures/cmaf change, out_playlist.m3u8 and its dependent playlists should be updated and checked if they are still playable. The current files have been checked with ffplay (FFmpeg) and Safari. ## Copyright and License Copyright 2019, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#usage","title":"MPEG-4 container plugin for Membrane Framework - Usage","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]